## rocksndiamonds 4.4.0.5+dfsg

=== Makefile ===
# =============================================================================
# Rocks'n'Diamonds - McDuffin Strikes Back!
# -----------------------------------------------------------------------------
# (c) 1995-2015 by Artsoft Entertainment
#                  Holger Schemel
#                  info@artsoft.org
#                  https://www.artsoft.org/
# -----------------------------------------------------------------------------
# Makefile
# =============================================================================

# -----------------------------------------------------------------------------
# configuration
# -----------------------------------------------------------------------------

# command name of your favorite ANSI C compiler
# (this must be set to "cc" for some systems)
CC = gcc

# command name of GNU make on your system
# (this must be set to "gmake" for some systems)
MAKE = make

# directory for (read-only) game data (like graphics, sounds, levels)
# (this directory is usually the game's installation directory)
# default is '.' to be able to run program without installation
# BASE_PATH = .
# use the following setting for Debian / Ubuntu installations:
# BASE_PATH = /usr/share/games/rocksndiamonds

# uncomment if system has no joystick include file
# JOYSTICK = -DNO_JOYSTICK

# path for cross-compiling (only needed for non-native Windows build)
CROSS_PATH_WIN32 = /usr/local/cross-tools/i686-w64-mingw32
CROSS_PATH_WIN64 = /usr/local/cross-tools/x86_64-w64-mingw32


# -----------------------------------------------------------------------------
# there should be no need to change anything below
# -----------------------------------------------------------------------------

.EXPORT_ALL_VARIABLES:

SRC_DIR = src
ANDROID_DIR ?= build-projects/android

MAKE_CMD = $(MAKE) -C $(SRC_DIR)
MAKE_CMD_ANDROID = $(MAKE) -C $(ANDROID_DIR)


# -----------------------------------------------------------------------------
# build targets
# -----------------------------------------------------------------------------

all:
	@$(MAKE_CMD)

cross-win32:
	@PATH=$(CROSS_PATH_WIN32)/bin:${PATH} $(MAKE_CMD) PLATFORM=cross-win32

cross-win64:
	@PATH=$(CROSS_PATH_WIN64)/bin:${PATH} $(MAKE_CMD) PLATFORM=cross-win64

android-prepare:
	@$(MAKE_CMD_ANDROID) prepare

android-package:
	@$(MAKE_CMD_ANDROID) package

android-clean:
	@$(MAKE_CMD_ANDROID) clean

android: android-package

emscripten:
	@emmake $(MAKE_CMD) PLATFORM=emscripten

clean:
	@$(MAKE_CMD) clean

clean-git:
	@$(MAKE_CMD) clean-git

clean-android: android-clean


# -----------------------------------------------------------------------------
# development targets
# -----------------------------------------------------------------------------

MAKE_ENGINETEST = ./tests/enginetest/enginetest.sh
MAKE_LEVELSKETCH = ./Scripts/make_levelsketch_images.sh

auto-conf:
	@$(MAKE_CMD) auto-conf

conf-time:
	@$(MAKE_CMD) conf-time

conf-hash:
	@$(MAKE_CMD) conf-hash

run: all
	@$(MAKE_CMD) run

gdb: all
	@$(MAKE_CMD) gdb

valgrind: all
	@$(MAKE_CMD) valgrind

tags:
	$(MAKE_CMD) tags

depend dep:
	$(MAKE_CMD) depend

depend-clean dep-clean:
	$(MAKE_CMD) depend-clean

enginetest: all
	$(MAKE_ENGINETEST)

levelsketch_images: all
	$(MAKE_LEVELSKETCH)


# -----------------------------------------------------------------------------
# distribution targets
# -----------------------------------------------------------------------------

MAKE_DIST = ./Scripts/make_dist.sh

dist-clean:
	@$(MAKE_CMD) dist-clean

dist-clean-android:
	@$(MAKE_CMD_ANDROID) dist-clean

dist-build-linux:
	@BUILD_DIST=TRUE $(MAKE)

dist-build-win32:
	@BUILD_DIST=TRUE $(MAKE) cross-win32

dist-build-win64:
	@BUILD_DIST=TRUE $(MAKE) cross-win64

dist-build-mac:
	@BUILD_DIST=TRUE $(MAKE)

dist-build-android:
	@BUILD_DIST=TRUE $(MAKE) android

dist-build-emscripten:
	@BUILD_DIST=TRUE $(MAKE) emscripten

dist-package-linux:
	$(MAKE_DIST) package linux

dist-package-win32:
	$(MAKE_DIST) package win32

dist-package-win64:
	$(MAKE_DIST) package win64

dist-package-mac:
	$(MAKE_DIST) package mac

dist-package-android:
	$(MAKE_DIST) package android

dist-package-emscripten:
	$(MAKE_DIST) package emscripten

dist-copy-package-linux:
	$(MAKE_DIST) copy-package linux

dist-copy-package-win32:
	$(MAKE_DIST) copy-package win32

dist-copy-package-win64:
	$(MAKE_DIST) copy-package win64

dist-copy-package-mac:
	$(MAKE_DIST) copy-package mac

dist-copy-package-android:
	$(MAKE_DIST) copy-package android

dist-copy-package-emscripten:
	$(MAKE_DIST) copy-package emscripten

dist-upload-linux:
	$(MAKE_DIST) upload linux

dist-upload-win32:
	$(MAKE_DIST) upload win32

dist-upload-win64:
	$(MAKE_DIST) upload win64

dist-upload-mac:
	$(MAKE_DIST) upload mac

dist-upload-android:
	$(MAKE_DIST) upload android

dist-upload-emscripten:
	$(MAKE_DIST) upload emscripten

dist-deploy-emscripten:
	$(MAKE_DIST) deploy emscripten

dist-package-all:
	$(MAKE) dist-package-linux
	$(MAKE) dist-package-win32
	$(MAKE) dist-package-win64
	$(MAKE) dist-package-mac
	$(MAKE) dist-package-android
	$(MAKE) dist-package-emscripten

dist-copy-package-all:
	$(MAKE) dist-copy-package-linux
	$(MAKE) dist-copy-package-win32
	$(MAKE) dist-copy-package-win64
	$(MAKE) dist-copy-package-mac
	$(MAKE) dist-copy-package-android
	$(MAKE) dist-copy-package-emscripten

dist-upload-all:
	$(MAKE) dist-upload-linux
	$(MAKE) dist-upload-win32
	$(MAKE) dist-upload-win64
	$(MAKE) dist-upload-mac
	$(MAKE) dist-upload-android
	$(MAKE) dist-upload-emscripten

dist-deploy-all:
	$(MAKE) dist-deploy-emscripten

dist-release-all: dist-package-all dist-copy-package-all dist-upload-all dist-deploy-all

package-all: dist-package-all

copy-package-all: dist-copy-package-all

upload-all: dist-upload-all

deploy-all: dist-deploy-all

release-all: dist-release-all

=== src/Makefile ===
# =============================================================================
# Rocks'n'Diamonds - McDuffin Strikes Back!
# -----------------------------------------------------------------------------
# (c) 1995-2015 by Artsoft Entertainment
#                  Holger Schemel
#                  info@artsoft.org
#                  https://www.artsoft.org/
# -----------------------------------------------------------------------------
# src/Makefile
# =============================================================================

# -----------------------------------------------------------------------------
# configuration
# -----------------------------------------------------------------------------

.EXPORT_ALL_VARIABLES:

ifndef PLATFORM				# unknown platform -- default to Unix
PLATFORM = unix
endif

PLATFORM_BASE = $(PLATFORM)

ifeq ($(PLATFORM),cross-win32)
PLATFORM_BASE = cross-win
endif
ifeq ($(PLATFORM),cross-win64)
PLATFORM_BASE = cross-win
endif

AR = ar
RANLIB = ranlib
ETAGS = etags
STRIP = strip
RM = rm -f

CONVERT = convert
WINDRES = windres

CONVERT_ICON_ARGS = -transparent black -background transparent

DEBUGGER = gdb -batch -ex "run" -ex "bt"

PROGBASE = rocksndiamonds
PROGNAME = ../$(PROGBASE)


# -----------------------------------------------------------------------------
# configuring platform
# -----------------------------------------------------------------------------

ifeq ($(PLATFORM),unix)			# compiling on Unix/Linux (generic)
PROFILING_FLAGS = -pg
endif

ifeq ($(PLATFORM_BASE),cross-win)	# cross-compiling to Windows
PROGNAME = ../$(PROGBASE).exe
EXTRA_LDFLAGS = -lshfolder -lwsock32
endif

ifeq ($(PLATFORM),emscripten)		# compiling with Emscripten
PROGNAME = ../$(PROGBASE).js
DATA_FILE = $(PROGBASE).data
CC = emcc
AR = emar
RANLIB = emranlib
STRIP = true
FILE_PACKAGER = file_packager
endif

ifeq ($(shell uname -s),Darwin)		# compiling on Mac OS X
DEBUGGER = lldb --batch -o "run" -k "bt" -k "quit"
SANITIZING_FLAGS = -fsanitize=undefined
ifdef BUILD_DIST			# distribution build
MAC_TARGET_VERSION_MIN = 10.7
EXTRA_FLAGS_MAC = -mmacosx-version-min=$(MAC_TARGET_VERSION_MIN)
EXTRA_CFLAGS = $(EXTRA_FLAGS_MAC)
EXTRA_LDFLAGS = $(EXTRA_FLAGS_MAC)
MACOSX_DEPLOYMENT_TARGET = $MAC_TARGET_VERSION_MIN
endif
endif

ifeq ($(shell uname -s),OS/2)		# compiling on OS/2
PROGNAME = ../$(PROGBASE).exe
EXTRA_LDFLAGS = -Zomf -Zbin-files -Zmap -lcx -Zhigh-mem
endif


# -----------------------------------------------------------------------------
# configuring target
# -----------------------------------------------------------------------------

ifndef TARGET				# auto-detect compiling for SDL2
  SDL_VERSION := $(shell sdl2-config --version 2> /dev/null)
  ifdef SDL_VERSION
    TARGET = sdl2
  else
    $(error SDL2 library not found)
  endif
endif

# $(info Using SDL version $(SDL_VERSION) [TARGET == $(TARGET)])

ifeq ($(TARGET),sdl2)			# compiling for SDL2 target
ifeq ($(PLATFORM),emscripten)
SDL_LIBS = -s USE_SDL_IMAGE=2 -s USE_SDL_MIXER=2 -s USE_SDL_NET=2 -s USE_MODPLUG=1 -s USE_MPG123=1 -s USE_ZLIB=1
SDL_FMTS = -s SDL2_IMAGE_FORMATS='["bmp","png","pcx","xpm"]' -s SDL2_MIXER_FORMATS='["mod","mp3"]'
EXTRA_CFLAGS = $(SDL_LIBS)
EXTRA_LDFLAGS = $(SDL_FMTS) -s INITIAL_MEMORY=81920000 -s ALLOW_MEMORY_GROWTH=1 -s FORCE_FILESYSTEM -s NO_EXIT_RUNTIME=0 -s ASYNCIFY -O2 -lidbfs.js
DATA_DIRS = conf docs levels graphics sounds music
FILE_PACKAGER_ARGS = --preload $(DATA_DIRS) --js-output=$(DATA_FILE).js
else
SDL_LIBS = -lSDL2_image -lSDL2_mixer -lSDL2_net
endif

SYS_CFLAGS := -DTARGET_SDL2 $(shell sdl2-config --cflags)
SYS_LDFLAGS := $(SDL_LIBS) $(shell sdl2-config --libs) -lm -lz
endif


# -----------------------------------------------------------------------------
# configuring compile-time definitions
# -----------------------------------------------------------------------------

ifdef BASE_PATH					# path to read-only game data
CONFIG_BASE_PATH = -DBASE_PATH="\"$(BASE_PATH)\""
endif

CONFIG = $(CONFIG_BASE_PATH) $(JOYSTICK)

DEBUG = -DDEBUG -g

# ANALYZE = $(PROFILING_FLAGS)
# ANALYZE = $(SANITIZING_FLAGS)

# OPTIONS = $(DEBUG) -Wall			# only for debugging purposes
# OPTIONS = $(DEBUG) -O2 -Wall			# only for debugging purposes
# OPTIONS = $(DEBUG) -Wall			# only for debugging purposes
OPTIONS = $(DEBUG) -Wall -Wstrict-prototypes -Wmissing-prototypes
# OPTIONS = $(DEBUG) -Wall -Wextra -Wstrict-prototypes -Wmissing-prototypes
# OPTIONS = $(DEBUG) -Wall -ansi -pedantic	# only for debugging purposes
# OPTIONS = -O2 -Wall -ansi -pedantic
# OPTIONS = -O2 -Wall
# OPTIONS = -O2

ifdef BUILD_TEST			# test build
OPTIONS := $(OPTIONS) -DTESTING
endif

ifdef BUILD_DIST			# distribution build
SYS_LDFLAGS := $(shell echo $(SYS_LDFLAGS) |	\
		       sed -e "s%-rpath,[^ ]*%-rpath,'\$$ORIGIN/lib'%")
OPTIONS = -O2 -Wall
endif

CFLAGS = $(OPTIONS) $(ANALYZE) $(SYS_CFLAGS)  $(EXTRA_CFLAGS) $(CONFIG)
LDFLAGS =           $(ANALYZE) $(SYS_LDFLAGS) $(EXTRA_LDFLAGS)


SRCS =	main.c		\
	conf_gfx.c	\
	conf_snd.c	\
	conf_mus.c	\
	conf_hlp.c	\
	init.c		\
	config.c	\
	events.c	\
	tools.c		\
	screens.c	\
	game.c		\
	editor.c	\
	files.c		\
	tape.c		\
	anim.c		\
	api.c		\
	network.c	\
	netserv.c

OBJS =	main.o		\
	conf_gfx.o	\
	conf_snd.o	\
	conf_mus.o	\
	conf_hlp.o	\
	init.o		\
	config.o	\
	events.o	\
	tools.o		\
	screens.o	\
	game.o		\
	editor.o	\
	files.o		\
	tape.o		\
	anim.o		\
	api.o		\
	network.o	\
	netserv.o

CNFS =	conf_gfx.h	\
	conf_snd.h	\
	conf_mus.h	\
	conf_chr.c	\
	conf_chr.h	\
	conf_cus.c	\
	conf_cus.h	\
	conf_grp.c	\
	conf_grp.h	\
	conf_emp.c	\
	conf_emp.h	\
	conf_e2g.c	\
	conf_esg.c	\
	conf_e2s.c	\
	conf_fnt.c	\
	conf_g2s.c	\
	conf_g2m.c	\
	conf_var.c	\
	conf_act.c

CNFS_CMD = ../build-scripts/create_element_defs.pl

TIMESTAMP_FILE = conftime.h
TIMESTAMP_FORMAT = %Y-%m-%d %H:%M

# use SOURCE_DATE_EPOCH, or else last Git commit date, or else current date
SOURCE_DATE_EPOCH ?= $(shell test -d ../.git && test `git ls-files -m | wc -l` -eq 0 && git show -s --format=%ct || date +%s)

# get source date string from either GNU / Linux or BSD / Mac OS X style "date"
SOURCE_DATE_STRING := $(shell date -u -d "@$(SOURCE_DATE_EPOCH)" "+$(TIMESTAMP_FORMAT)"  2>/dev/null || date -u -r "$(SOURCE_DATE_EPOCH)" "+$(TIMESTAMP_FORMAT)" 2>/dev/null || date -u "+$(TIMESTAMP_FORMAT)")

COMMIT_HASH_FILE = confhash.h
COMMIT_HASH_NONE = "[changed files]"

# get last Git commit hash, if no files were changed
SOURCE_HASH_STRING ?= $(shell test -d ../.git && test `git ls-files -m | wc -l` -eq 0 && git show -s --format=%h || echo "$(COMMIT_HASH_NONE)")

LIBGAME_DIR = libgame
LIBGAME = $(LIBGAME_DIR)/libgame.a

GAME_BD_DIR = game_bd
GAME_BD = $(GAME_BD_DIR)/game_bd.a

GAME_EM_DIR = game_em
GAME_EM = $(GAME_EM_DIR)/game_em.a

GAME_SP_DIR = game_sp
GAME_SP = $(GAME_SP_DIR)/game_sp.a

GAME_MM_DIR = game_mm
GAME_MM = $(GAME_MM_DIR)/game_mm.a

RNDLIBS = $(GAME_BD) $(GAME_EM) $(GAME_SP) $(GAME_MM) $(LIBGAME)
AUTOCONF = conf_gfx.h conf_snd.h conf_mus.h

ICONBASE = windows_icon
ICON_BASEPATH = ../build-projects/windows/icons

ifeq ($(PLATFORM_BASE),cross-win)
ICON_PATH = $(ICON_BASEPATH)
ICON = $(ICONBASE).o
endif

GRAPHICS_DIR = ../graphics


# -----------------------------------------------------------------------------
# build targets
# -----------------------------------------------------------------------------

all: $(AUTOCONF) libgame_dir game_bd_dir game_em_dir game_sp_dir game_mm_dir $(PROGNAME) graphics_dir

$(PROGNAME): $(RNDLIBS) $(TIMESTAMP_FILE) $(COMMIT_HASH_FILE) $(OBJS) $(ICON)
	$(CC) $(OBJS) $(ICON) $(RNDLIBS) $(LDFLAGS) -o $(PROGNAME)
ifdef BUILD_DIST
	$(STRIP) $(PROGNAME)
endif
ifeq ($(PLATFORM),emscripten)
	(cd .. ; $(FILE_PACKAGER) $(DATA_FILE) $(FILE_PACKAGER_ARGS))
endif

libgame_dir:
	@$(MAKE) -C $(LIBGAME_DIR)
$(LIBGAME):
	@$(MAKE) -C $(LIBGAME_DIR)

game_bd_dir:
	@$(MAKE) -C $(GAME_BD_DIR)
$(GAME_BD):
	@$(MAKE) -C $(GAME_BD_DIR)

game_em_dir:
	@$(MAKE) -C $(GAME_EM_DIR)
$(GAME_EM):
	@$(MAKE) -C $(GAME_EM_DIR)

game_sp_dir:
	@$(MAKE) -C $(GAME_SP_DIR)
$(GAME_SP):
	@$(MAKE) -C $(GAME_SP_DIR)

game_mm_dir:
	@$(MAKE) -C $(GAME_MM_DIR)
$(GAME_MM):
	@$(MAKE) -C $(GAME_MM_DIR)

auto-conf:
	@for i in $(CNFS); do			\
		echo "$(CNFS_CMD) $$i > $$i";	\
		$(CNFS_CMD) $$i > $$i;		\
	done

auto-conf-clean:
	@for i in $(CNFS); do			\
		echo "$(RM) $$i";		\
		$(RM) $$i;			\
	done

conf_gfx.h: conf_gfx.c $(CNFS_CMD)
	@$(MAKE) auto-conf

conf_snd.h: conf_snd.c $(CNFS_CMD)
	@$(MAKE) auto-conf

conf_mus.h: conf_mus.c $(CNFS_CMD)
	@$(MAKE) auto-conf

conf-time:
	@echo '#define SOURCE_DATE_STRING "$(SOURCE_DATE_STRING)"' \
	> $(TIMESTAMP_FILE)

conf-hash:
	@echo '#define SOURCE_HASH_STRING "$(SOURCE_HASH_STRING)"' \
	> $(COMMIT_HASH_FILE)

config.o: config.c $(TIMESTAMP_FILE)

$(TIMESTAMP_FILE): $(SRCS) $(RNDLIBS)
	@$(MAKE) conf-time

$(COMMIT_HASH_FILE): $(SRCS) $(RNDLIBS)
	@$(MAKE) conf-hash

$(ICON):
	$(CONVERT) $(ICON_PATH)/*.png $(CONVERT_ICON_ARGS) $(ICONBASE).ico
	echo "$(ICONBASE) ICON $(ICONBASE).ico" | $(WINDRES) -o $(ICON)

.c.o:
	$(CC) $(CFLAGS) -c $*.c

graphics_dir:
	@test -f $(GRAPHICS_DIR)/Makefile && $(MAKE) -C $(GRAPHICS_DIR) || true

clean-obj:
	$(MAKE) -C $(LIBGAME_DIR) clean
	$(MAKE) -C $(GAME_BD_DIR) clean
	$(MAKE) -C $(GAME_EM_DIR) clean
	$(MAKE) -C $(GAME_SP_DIR) clean
	$(MAKE) -C $(GAME_MM_DIR) clean
	$(RM) $(OBJS)
	$(RM) $(RNDLIBS)

clean-ico:
	$(RM) $(ICONBASE).ico
	$(RM) $(ICONBASE).o

clean-bin:
	$(RM) $(PROGNAME)
	$(RM) $(PROGNAME).exe
	$(RM) $(PROGNAME).js
	$(RM) $(PROGNAME).wasm
	$(RM) $(PROGNAME).data

clean: clean-obj clean-ico clean-bin

clean-git: clean auto-conf-clean
	@$(MAKE) -C $(GRAPHICS_DIR) clean

dist-clean: clean-obj clean-ico


# -----------------------------------------------------------------------------
# run and test targets
# -----------------------------------------------------------------------------

run:
	cd .. && ./$(PROGBASE) --verbose

gdb:
	cd .. && $(DEBUGGER) $(PROGBASE)

valgrind:
	cd .. && valgrind -v --leak-check=yes ./$(PROGBASE) 2> valgrind.out


# -----------------------------------------------------------------------------
# development only
# -----------------------------------------------------------------------------

tags:
	$(ETAGS) *.[ch] $(LIBGAME_DIR)/*.[ch] $(GAME_BD_DIR)/*.[ch] $(GAME_EM_DIR)/*.[ch] $(GAME_SP_DIR)/*.[ch] $(GAME_MM_DIR)/*.[ch]

depend:
	$(MAKE) -C $(LIBGAME_DIR) depend
	$(MAKE) -C $(GAME_BD_DIR) depend
	$(MAKE) -C $(GAME_EM_DIR) depend
	$(MAKE) -C $(GAME_SP_DIR) depend
	$(MAKE) -C $(GAME_MM_DIR) depend
	for i in $(SRCS); do $(CPP) $(CFLAGS) -M $$i; done > .depend

depend-clean:
	$(MAKE) -C $(LIBGAME_DIR) depend-clean
	$(MAKE) -C $(GAME_BD_DIR) depend-clean
	$(MAKE) -C $(GAME_EM_DIR) depend-clean
	$(MAKE) -C $(GAME_SP_DIR) depend-clean
	$(MAKE) -C $(GAME_MM_DIR) depend-clean
	$(RM) .depend

ifeq (.depend,$(wildcard .depend))
include .depend
endif

=== src/game_bd/Makefile ===
# =============================================================================
# Rocks'n'Diamonds - McDuffin Strikes Back!
# -----------------------------------------------------------------------------
# (c) 1995-2024 by Artsoft Entertainment
#                  Holger Schemel
#                  info@artsoft.org
#                  https://www.artsoft.org/
# -----------------------------------------------------------------------------
# The native Boulder Dash game engine is based on:
# - GDash by Czirkos Zoltan (2010)
# -----------------------------------------------------------------------------
# src/game_bd/Makefile
# =============================================================================

# -----------------------------------------------------------------------------
# configuration
# -----------------------------------------------------------------------------

SRCS =	main_bd.c	\
	bd_cave.c	\
	bd_cavedb.c	\
	bd_caveengine.c	\
	bd_caveobject.c	\
	bd_bdcff.c	\
	bd_caveset.c	\
	bd_c64import.c	\
	bd_gameplay.c	\
	bd_graphics.c	\
	bd_colors.c	\
	bd_random.c	\
	bd_sound.c

OBJS =	main_bd.o	\
	bd_cave.o	\
	bd_cavedb.o	\
	bd_caveengine.o	\
	bd_caveobject.o	\
	bd_bdcff.o	\
	bd_caveset.o	\
	bd_c64import.o	\
	bd_gameplay.o	\
	bd_graphics.o	\
	bd_colors.o	\
	bd_random.o	\
	bd_sound.o

GAME_BD = game_bd.a


# -----------------------------------------------------------------------------
# build targets
# -----------------------------------------------------------------------------

all: $(GAME_BD)

$(GAME_BD): $(OBJS)
	$(AR) cr $(GAME_BD) $(OBJS)
	$(RANLIB) $(GAME_BD)

.c.o:
	$(CC) $(PROFILING) $(CFLAGS) -c $*.c

clean:
	$(RM) $(OBJS)
	$(RM) $(GAME_BD)


# -----------------------------------------------------------------------------
# development only
# -----------------------------------------------------------------------------

depend:
	for i in $(SRCS); do $(CPP) $(CFLAGS) -M $$i; done > .depend

depend-clean:
	$(RM) .depend

ifeq (.depend,$(wildcard .depend))
include .depend
endif

=== src/game_mm/Makefile ===
# =============================================================================
# Rocks'n'Diamonds - McDuffin Strikes Back!
# -----------------------------------------------------------------------------
# (c) 1989-2017 by Artsoft Entertainment
#                  Holger Schemel
#                  info@artsoft.org
#                  https://www.artsoft.org/
# -----------------------------------------------------------------------------
# The native Mirror Magic game engine is based on:
# - Mirror Magic II by Holger Schemel (Linux/DOS/Windows version, 1995)
# - Mindbender by Holger Schemel (Amiga version, 1989)
# -----------------------------------------------------------------------------
# src/game_mm/Makefile
# =============================================================================

# -----------------------------------------------------------------------------
# configuration
# -----------------------------------------------------------------------------

SRCS =	mm_init.c		\
	mm_main.c		\
	mm_game.c		\
	mm_files.c		\
	mm_tools.c

OBJS =	mm_init.o		\
	mm_main.o		\
	mm_game.o		\
	mm_files.o		\
	mm_tools.o

GAME_MM = game_mm.a


# -----------------------------------------------------------------------------
# build targets
# -----------------------------------------------------------------------------

all: $(GAME_MM)

$(GAME_MM): $(OBJS)
	$(AR) cr $(GAME_MM) $(OBJS)
	$(RANLIB) $(GAME_MM)

.c.o:
	$(CC) $(PROFILING) $(CFLAGS) -c $*.c

clean:
	$(RM) $(OBJS)
	$(RM) $(GAME_MM)


# -----------------------------------------------------------------------------
# development only
# -----------------------------------------------------------------------------

depend:
	for i in $(SRCS); do $(CPP) $(CFLAGS) -M $$i; done > .depend

depend-clean:
	$(RM) .depend

ifeq (.depend,$(wildcard .depend))
include .depend
endif

=== src/game_sp/Makefile ===
# =============================================================================
# Rocks'n'Diamonds - McDuffin Strikes Back!
# -----------------------------------------------------------------------------
# (c) 1995-2014 by Artsoft Entertainment
#                  Holger Schemel
#                  info@artsoft.org
#                  https://www.artsoft.org/
# -----------------------------------------------------------------------------
# The native Supaplex game engine is based on:
# - MegaPlex version 0.5 beta release xmas 2001 by Frank Schindler
# - Speed Fix 6.3+ by Herman Perk
# - Supaplex by Michael Stopp & Philip Jespersen
# -----------------------------------------------------------------------------
# src/game_sp/Makefile
# =============================================================================

# -----------------------------------------------------------------------------
# configuration
# -----------------------------------------------------------------------------

SRCS =	init.c			\
	file.c			\
	main.c			\
	vb_lib.c		\
				\
	ASM.c			\
	BugsTerminals.c		\
	DDScrollBuffer.c	\
	DDSpriteBuffer.c	\
	Display.c		\
	DoGameStuff.c		\
	Electrons.c		\
	Explosions.c		\
	Globals.c		\
	Infotrons.c		\
	InitGameConditions.c	\
	Input.c			\
	MainForm.c		\
	MainGameLoop.c		\
	Murphy.c		\
	OrangeDisk.c		\
	SnikSnaks.c		\
	Sound.c			\
	Zonk.c

OBJS =	init.o			\
	file.o			\
	main.o			\
	vb_lib.o		\
				\
	ASM.o			\
	BugsTerminals.o		\
	DDScrollBuffer.o	\
	DDSpriteBuffer.o	\
	Display.o		\
	DoGameStuff.o		\
	Electrons.o		\
	Explosions.o		\
	Globals.o		\
	Infotrons.o		\
	InitGameConditions.o	\
	Input.o			\
	MainForm.o		\
	MainGameLoop.o		\
	Murphy.o		\
	OrangeDisk.o		\
	SnikSnaks.o		\
	Sound.o			\
	Zonk.o

GAME_SP = game_sp.a


# -----------------------------------------------------------------------------
# build targets
# -----------------------------------------------------------------------------

all: $(GAME_SP)

$(GAME_SP): $(OBJS)
	$(AR) cr $(GAME_SP) $(OBJS)
	$(RANLIB) $(GAME_SP)

.c.o:
	$(CC) $(PROFILING) $(CFLAGS) -c $*.c

clean:
	$(RM) $(OBJS)
	$(RM) $(GAME_SP)


# -----------------------------------------------------------------------------
# development only
# -----------------------------------------------------------------------------

depend:
	for i in $(SRCS); do $(CPP) $(CFLAGS) -M $$i; done > .depend

depend-clean:
	$(RM) .depend

ifeq (.depend,$(wildcard .depend))
include .depend
endif

=== src/libgame/Makefile ===
# =============================================================================
# Rocks'n'Diamonds - McDuffin Strikes Back!
# -----------------------------------------------------------------------------
# (c) 1995-2014 by Artsoft Entertainment
#                  Holger Schemel
#                  info@artsoft.org
#                  https://www.artsoft.org/
# -----------------------------------------------------------------------------
# src/libgame/Makefile
# =============================================================================

# -----------------------------------------------------------------------------
# configuration
# -----------------------------------------------------------------------------

SRCS =	system.c	\
	gadgets.c	\
	text.c		\
	sound.c		\
	joystick.c	\
	snapshot.c	\
	image.c		\
	random.c	\
	hash.c		\
	list.c		\
	http.c		\
	base64.c	\
	setup.c		\
	misc.c		\
	sdl.c		\
	zip/ioapi.c	\
	zip/iowin32.c	\
	zip/unzip.c	\
	zip/miniunz.c

OBJS =	system.o	\
	gadgets.o	\
	text.o		\
	sound.o		\
	snapshot.o	\
	joystick.o	\
	image.o		\
	random.o	\
	hash.o		\
	list.o		\
	http.o		\
	base64.o	\
	setup.o		\
	misc.o		\
	sdl.o		\
	zip/ioapi.o	\
	zip/iowin32.o	\
	zip/unzip.o	\
	zip/miniunz.o

LIBGAME = libgame.a


# -----------------------------------------------------------------------------
# build targets
# -----------------------------------------------------------------------------

all: $(LIBGAME)

$(LIBGAME): $(OBJS)
	$(AR) cr $(LIBGAME) $(OBJS)
	$(RANLIB) $(LIBGAME)

.c.o:
	$(CC) $(PROFILING) $(CFLAGS) -c $*.c -o $*.o

clean:
	$(RM) $(OBJS)
	$(RM) $(LIBGAME)


# -----------------------------------------------------------------------------
# development only
# -----------------------------------------------------------------------------

depend:
	for i in $(SRCS); do $(CPP) $(CFLAGS) -M $$i; done > .depend

depend-clean:
	$(RM) .depend

ifeq (.depend,$(wildcard .depend))
include .depend
endif

=== debian/changelog ===
rocksndiamonds (4.4.0.5+dfsg-1) unstable; urgency=medium

  * New upstream release, merging spelling-fixes.patch.
  * Add Catalan translation of the debconf messages; thanks Carles Pina i
    Estany!
  * Remove the old FSF address from debian/copyright.
  * Drop “Rules-Requires-Root: no” since it’s now the default.
  * Standards-Version 4.7.2, no further change required.

 -- Stephen Kitt <skitt@debian.org>  Sat, 04 Oct 2025 15:26:26 +0200

=== debian/watch ===
version=4
opts=repacksuffix=+dfsg,dversionmangle=auto,uversionmangle=s/-linux// \
https://artsoft.org/rocksndiamonds/download/ \
(?:.*/|.*=|)rocksndiamonds[\-\._](\d\S*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)(?:/\S*)?

## rocksndiamonds 4.4.1.3+dfsg

=== src/Makefile ===
--- 
+++ 
@@ -106,7 +106,7 @@
 SDL_LIBS = -s USE_SDL_IMAGE=2 -s USE_SDL_MIXER=2 -s USE_SDL_NET=2 -s USE_MODPLUG=1 -s USE_MPG123=1 -s USE_ZLIB=1
 SDL_FMTS = -s SDL2_IMAGE_FORMATS='["bmp","png","pcx","xpm"]' -s SDL2_MIXER_FORMATS='["mod","mp3"]'
 EXTRA_CFLAGS = $(SDL_LIBS)
-EXTRA_LDFLAGS = $(SDL_FMTS) -s INITIAL_MEMORY=81920000 -s ALLOW_MEMORY_GROWTH=1 -s FORCE_FILESYSTEM -s NO_EXIT_RUNTIME=0 -s ASYNCIFY -O2 -lidbfs.js
+EXTRA_LDFLAGS = $(SDL_FMTS) -s INITIAL_MEMORY=104857600 -s ALLOW_MEMORY_GROWTH=1 -s FORCE_FILESYSTEM -s NO_EXIT_RUNTIME=0 -s ASYNCIFY -O2 -lidbfs.js
 DATA_DIRS = conf docs levels graphics sounds music
 FILE_PACKAGER_ARGS = --preload $(DATA_DIRS) --js-output=$(DATA_FILE).js
 else

=== debian/changelog ===
rocksndiamonds (4.4.1.3+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Update the Emerald Mine Club level set.
  * Drop “Priority: optional” since it’s now the default.
  * Standards-Version 4.7.3, no further change required.
  * Update debian/watch to version 5.

 -- Stephen Kitt <skitt@debian.org>  Wed, 21 Jan 2026 19:01:27 +0100

=== debian/control ===
Source: rocksndiamonds
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Dmitry E. Oboukhov <unera@debian.org>, Stephen Kitt <skitt@debian.org>
Section: contrib/games
Build-Depends: debhelper-compat (= 13),
               po-debconf,
               libsdl2-dev,
               libsdl2-image-dev,
               libsdl2-mixer-dev,
               libsdl2-net-dev
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/games-team/rocksndiamonds
Vcs-Git: https://salsa.debian.org/games-team/rocksndiamonds.git
Homepage: https://artsoft.org

Package: rocksndiamonds
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${perl:Depends},
         7zip,
         wget,
         unzip,
         zip
Pre-Depends: debconf | debconf-2.0
Conflicts: rocksndiamonds-data,
           rocksndiamonds-zelda,
           rocks-n-diamonds
Description: arcade-style game
 This package provides the game engine for Rocks'n'Diamonds, an arcade
 game in the tradition of "Boulder Dash", "Emerald Mine", "Supaplex",
 "Sokoban", etcetera. Game levels emulating all of these can be
 downloaded from ArtSoft.org.

=== debian/watch ===
Version: 5

Source: https://artsoft.org/rocksndiamonds/download/
Matching-Pattern: (?:.*/|.*=|)rocksndiamonds[\-\._](\d\S*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)(?:/\S*)?
Dversionmangle: auto
Repacksuffix: +dfsg
Uversionmangle: s/-linux//
